<?php 

namespace Kitt3n\AzureAdForSymfonyBundle\Entity;

use Kitt3n\SingleSignOnForSymfonyBundle\Entity\Identity as GenericIdentity;

class Identity extends GenericIdentity
{

    protected string $username;

    protected string $password;
    
    protected string $email;

	protected string $firstname;

	protected string $lastname;

    protected array $groupIds = [];

	protected array $appRoleIds = [];

	protected bool $backendAccess = false;

	protected bool $frontendAccess = false;

	protected bool $admin = false;
	
	/**
	 * __construct
	 * 
	 * @param string $token
	 * @param int $time
	 * @param int $expires
	 * @param string $username
	 * @param string $password
	 * @param string $email
	 * @param string $firstname
	 * @param string $lastname
	 * @param array $groupIds
	 * @param array $appRoleIds
	 * @param bool $backendAccess
	 * @param bool $frontendAccess
	 * @param bool $admin
	 */
	public function __construct(
		string $token,
		int $time,
		int $expires,
		string $username,
		string $password,
		string $email,
		string $firstname = '',
		string $lastname = '',
		array $groupIds = [],
		array $appRoleIds = [],
		bool $backendAccess = false,
		bool $frontendAccess = false,
		bool $admin = false
	){
		parent::__construct($token, $time, $expires);
		$this->username = $username;//$this->_md5($username);
		$this->password = $password;
		$this->email = $email;
		$this->firstname = $firstname;
		$this->lastname = $lastname;
		$this->groupIds = $groupIds;
		$this->appRoleIds = $appRoleIds;
		$this->backendAccess = $backendAccess;
		$this->frontendAccess = $frontendAccess;
		$this->admin = $admin;
	}
    
	public function _md5($value): string
	{
		return md5($value);
	}

	/**
	 * 
	 * @return string
	 */
	function getUsername(): string {
		return $this->username;
	}
	
	/**
	 * 
	 * @param string $username 
	 * @return Identity
	 */
	function setUsername(string $username): self {
		$this->username = $username;//$this->_md5($username);
		return $this;
	}
	/**
	 * 
	 * @return string
	 */
	function getPassword(): string {
		return $this->password;
	}
	
	/**
	 * 
	 * @param string $password 
	 * @return Identity
	 */
	function setPassword(string $password): self {
		$this->password = $password;
		return $this;
	}
	/**
	 * 
	 * @return string
	 */
	function getEmail(): string {
		return $this->email;
	}
	
	/**
	 * 
	 * @param string $email 
	 * @return Identity
	 */
	function setEmail(string $email): self {
		$this->email = $email;
		return $this;
	}
	/**
	 * 
	 * @return array
	 */
	function getGroupIdentitys(): array {
		return $this->groupIdentitys;
	}
	
	/**
	 * 
	 * @param array $groupIdentitys 
	 * @return Identity
	 */
	function setGroupIdentitys(array $groupIdentitys): self {
		$this->groupIdentitys = $groupIdentitys;
		return $this;
	}
	/**
	 * 
	 * @return array
	 */
	function getGroupIds(): array {
		return $this->groupIds;
	}
	
	/**
	 * 
	 * @param array $groupIds 
	 * @return Identity
	 */
	function setGroupIds(array $groupIds): self {
		$this->groupIds = $groupIds;
		return $this;
	}
	/**
	 * 
	 * @return array
	 */
	function getAppRoleIds(): array {
		return $this->appRoleIds;
	}
	
	/**
	 * 
	 * @param array $appRoleIds 
	 * @return Identity
	 */
	function setAppRoleIds(array $appRoleIds): self {
		$this->appRoleIds = $appRoleIds;
		return $this;
	}
	/**
	 * 
	 * @return bool
	 */
	function getBackendAccess(): bool {
		return $this->backendAccess;
	}
	
	/**
	 * 
	 * @param bool $backendAccess 
	 * @return Identity
	 */
	function setBackendAccess(bool $backendAccess): self {
		$this->backendAccess = $backendAccess;
		return $this;
	}
	/**
	 * 
	 * @return bool
	 */
	function getFrontendAccess(): bool {
		return $this->frontendAccess;
	}
	
	/**
	 * 
	 * @param bool $frontendAccess 
	 * @return Identity
	 */
	function setFrontendAccess(bool $frontendAccess): self {
		$this->frontendAccess = $frontendAccess;
		return $this;
	}
	/**
	 * 
	 * @return string
	 */
	function getFirstname(): string {
		return $this->firstname;
	}
	
	/**
	 * 
	 * @param string $firstname 
	 * @return Identity
	 */
	function setFirstname(string $firstname): self {
		$this->firstname = $firstname;
		return $this;
	}
	/**
	 * 
	 * @return string
	 */
	function getLastname(): string {
		return $this->lastname;
	}
	
	/**
	 * 
	 * @param string $lastname 
	 * @return Identity
	 */
	function setLastname(string $lastname): self {
		$this->lastname = $lastname;
		return $this;
	}
	/**
	 * 
	 * @return bool
	 */
	function getAdmin(): bool {
		return $this->admin;
	}
	
	/**
	 * 
	 * @param bool $admin 
	 * @return Identity
	 */
	function setAdmin(bool $admin): self {
		$this->admin = $admin;
		return $this;
	}
}